#ifndef EVENTS_H
#define EVENTS_H

#define DCC_RECV_SIGNATURE(event_name) \
    void event_name (irc_session_t * session, irc_dcc_t id, int status, void * ctx, const char * data, unsigned int length)

#define EVENT_DCC_CHAT_SIGNATURE(event_name) \
    void event_name (irc_session_t * session, const char * nick, const char * addr, irc_dcc_t dccid)

#define EVENT_DCC_SEND_SIGNATURE(event_name) \
    void event_name (irc_session_t * session, const char * nick, const char * addr, const char * filename, unsigned long size, irc_dcc_t dccid)

#define EVENT_GENERIC_SIGNATURE(event_name) \
    void event_name (irc_session_t * session, const char *event, const char *origin, const char **params, unsigned int count)

#define EVENT_NUMERIC_SIGNATURE(event_name) \
    void event_name (irc_session_t * session, unsigned int event, const char *origin, const char **params, unsigned int count)

DCC_RECV_SIGNATURE(dcc_file_recv_callback);
DCC_RECV_SIGNATURE(dcc_recv_callback);
EVENT_DCC_CHAT_SIGNATURE(irc_event_dcc_chat);
EVENT_DCC_SEND_SIGNATURE(irc_event_dcc_send);
EVENT_GENERIC_SIGNATURE(dump_event);
EVENT_GENERIC_SIGNATURE(irc_event_channel);
EVENT_GENERIC_SIGNATURE(irc_event_connect);
EVENT_GENERIC_SIGNATURE(irc_event_join);
EVENT_GENERIC_SIGNATURE(irc_event_nick);
EVENT_GENERIC_SIGNATURE(irc_event_privmsg);
EVENT_NUMERIC_SIGNATURE(irc_event_numeric);

#endif                          /* EVENTS_H */
